var app = new Vue({
    el: '#app',
    mixins: [mixinCards],
    data: {
        curso: '',
        menu: '',
        menuSelected: 0,
        start: 0,
        end: 0,
        contentSelected: 0,
        selectedLink: false,
        contentLink: '',
        drawer: null,
        recurso: '',
        mobileBreakPoint: 1264,
        progresso: [],
        e6: 1,
        valueResp: '',
        feedbackAux: '',
        feedback: '',
        feedbackCard: '',
        status: '',
        position: '',
        dialog: {},
        dialog1: false,
        dialog2: false,
        dialog3: false
    },
    created: function () {
        if (!localStorage.getItem('progresso')) {
            localStorage.setItem("progresso", JSON.stringify([
                {"tema": 0},
                {"tema": 0},
                {"tema": 0}
            ]));
        }
        this.status = JSON.parse(localStorage.getItem('progresso'));
        this.$http.get('course.json').then(function (response) {
            this.curso = response.body.course;
            this.recurso = this.curso.menu[this.menuSelected];
            this.iniciarCard('stacked-cards-block-0');
            this.checkMobile();
        });
    },
    watch: {
        start: function () {
            if (this.start === '') {
                this.checkMobile();
            }
        }
    },
    methods: {
        left: function () {
            if (!(this.currentPosition >= this.maxElements)) {
                if (this.useOverlays) {
                    this.leftObj.classList.remove('no-transition');
                    this.topObj.classList.remove('no-transition');
                    this.leftObj.style.zIndex = '8';
                    this.transformUi(0, 0, 1, leftObj);
                }
                this.onSwipeLeft();
                this.resetOverlayLeft();
            }
            if (this.recurso.conteudo.length - 1 === this.currentPosition) {
                this.end = 1;
                this.statusUpdate();
            } else {
                this.end = 0;
            }
            this.transAfterMove();
            if (this.currentElementObj === undefined) {
                this.recurso = '';
                setTimeout(function () {
                    this.app.menuSelect(this.app.menuSelected + 1)
                }, 0);
            }
        },
        right: function () {
            if (!(this.currentPosition >= this.maxElements)) {
                if (this.useOverlays) {
                    this.rightObj.classList.remove('no-transition');
                    this.topObj.classList.remove('no-transition');
                    this.rightObj.style.zIndex = '8';
                    this.transformUi(0, 0, 1, rightObj);
                }
                this.onSwipeRight();
                this.resetOverlayRight();
            }
            this.transAfterMove();
        },
        transAfterMove: function () {
            setTimeout(function () {
                this.app.feedback = '';
            }, 0);
        },
        // iniciar: function (index) {
        //   this.menuSelect(1);
        // },
        // proximo: function (index) {
        //   this.contentSelected++;
        //   this.recurso = this.curso.menu[this.menuSelected];
        //   this.generateProgress();
        //   this.statusUpdate(index);
        // },
        // anterior: function () {
        //   this.contentSelected--;
        // },
        resp: function (value, question, type) {
            if (type !== 'question-item-response') {
                if (value.c === true) {
                    this.feedbackAux = question[0].descricao;
                } else {
                    this.feedbackAux = question[1].descricao;
                }
            } else {
                this.feedbackAux = question.descricao;
            }
            this.feedbackCard = this.feedbackAux;
            this.left();
        },
        menuSelect: function (value) {
            this.recurso = '';
            this.end = 0;
            setTimeout(function () {
                if (value < 0) {
                    this.app.menuSelected = 0;
                } else {
                    this.app.menuSelected = value;
                    this.app.contentSelected = 0;
                    this.app.selectedLink = false;
                    this.app.recurso = this.app.curso.menu[this.app.menuSelected];
                    this.app.currentPosition = 0;
                }
                this.app.start = 1;
                var contentId = 'stacked-cards-block-' + this.app.menuSelected;
                this.app.iniciarCard(contentId);
                this.app.checkMobile();
            }, 0);
            this.end = 0;
        },
        linkSelected: function (value, items) {
            this.dialog[items.dialog] = true;
            this.currentCourse = this.selectedCourse;
            this.selectedLink = value;
            this.contentLink = items;
            this.end = false;
            this.checkMobile();
        },
        checkMobile: function () {
            var w = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
            // var h = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
            if (w <= this.mobileBreakPoint) {
                this.drawer = false;
            }
        },
        statusUpdate: function () {
            if (this.menuSelected === 1) {
                this.status[0].tema = 1;
                localStorage.setItem("progresso", JSON.stringify(this.status));
            }
            if (this.menuSelected === 2) {
                this.status[1].tema = 1;
                localStorage.setItem("progresso", JSON.stringify(this.status));
            }
            if (this.menuSelected === 3) {
                this.status[2].tema = 1;
                localStorage.setItem("progresso", JSON.stringify(this.status));
            }
        },
        generateProgress: function (index, param) {
            this.progresso[this.menuSelected] = [];
            var statusProgress = unasus.pack.getStatus().progresso;
            if (!param) {
                statusProgress = unasus.pack.getStatus().progresso[this.menuSelected];
            }
            if (!statusProgress) {
                console.log(this.progresso[this.menuSelected].push);
                for (i = 0; i < this.recurso.conteudo.length; i++) {
                    alert('item_' + i);
                    //this.progresso[this.menuSelected].push({['item_' + i]: false})
                }
                gravarStatus('progresso', this.progresso);
            }
            this.statusUpdate(index);
        },
        shareFacebook: function (item) {
            FB.ui({
                method: 'share_open_graph',
                action_type: 'og.shares',
                mobile_iframe: false,
                action_properties: JSON.stringify({
                    object: {
                        title: 'Compartilhe!',
                        description: this.cleanHtml(item.descricao + ' #febreamarela, #fato, #fiocruz, #vacinacao, #unasusnarede'),
                        image: this.getBaseUrl(item.image),
                        url: 'https://campusvirtual.fiocruz.br/febreamarela'
                    }
                })
            }, function (response) {
            });
        },
        sharetwitter: function (item) {
            var description = encodeURIComponent(this.cleanHtml(item.desc));
            var hashtags = 'febreamarela,fato,fiocruz,vacinacao,unasusnarede';
            var link = 'https://t.co/TsQWcIASjr';
            return "https://twitter.com/intent/tweet?url="+link+"&text=" + description + "&hashtags=" + hashtags + "&wrap_links=true";
        },
        cleanHtml: function strip_html_tags(str) {
            if ((str === null) || (str === ''))
                return false;
            else
                var semHtml = str.replace(/<[^>]*>/g, '').replace(/&nbsp;/g, " ").replace(/&eacute;/g, " ").replace(/; /g, "%3B");
            var parser = new DOMParser;
            var dom = parser.parseFromString(
                '<!doctype html><body>' + semHtml,
                'text/html');
            return dom.body.textContent;
        },
        getCheck: function (value) {
            if (value !== undefined) {
                var retorno = this.status[value - 1].tema;
            }
            return retorno;
        },
        closeDialog: function () {
            this.dialog = {};
            this.selectedLink = false;
            this.drawer = true
        },
        getBaseUrl: function (value) {
            if (value) {
                return window.location.href + value;
            } else {
                return window.location.href;
            }
        }
    }
});
//habilita devtools no chrome
Vue.config.devtools = 1;