// define um objeto mixin
var mixinCards = {
  data: function () {
    return {
      stackedOptions: 'None', //Change stacked cards view from 'Bottom', 'Top' or 'None'.
      rotate: false, //Activate the elements' rotation for each move on stacked cards.
      items: 3, //Number of visible elements when the stacked options are bottom or top.
      elementsMargin: 10, //Define the distance of each element when the stacked options are bottom or top.
      useOverlays: false, //Enable or disable the overlays for swipe elements.
      maxElements: '', //Total of stacked cards on DOM.
      currentPosition: 0, //Keep the position of active stacked card.
      velocity: 0.3, //Minimum velocity allowed to trigger a swipe.
      topObj: '', //Keep the swipe top properties.
      rightObj: '', //Keep the swipe right properties.
      leftObj: '', //Keep the swipe left properties.
      listElNodesObj: '', //Keep the list of nodes from stacked cards.
      listElNodesWidth: '', //Keep the stacked cards width.
      currentElementObj: '', //Keep the stacked card element to swipe.
      stackedCardsObj: '',
      isFirstTime: true,
      elementHeight: '',
      obj: '',
      elTrans: '',
      valueDeterminate: 20,
      body: ''
    }
  },
  created: function () {
  },
  updated: function () {
    this.$nextTick(function () {
    })
  },
  methods: {
    updateCard: function () {
      requestAnimationFrame(function () {
        this.elTrans = 0;
        var listElNodesObj = this.app.listElNodesObj;
        var elZindex = 5;
        var elScale = 1;
        var elOpac = 1;
        var elTransTop = this.app.items;
        var elTransInc = this.app.elementsMargin;

        for (i = this.app.currentPosition; i < (this.app.currentPosition + this.app.items); i++) {
          if (listElNodesObj[i]) {
            if (this.app.stackedOptions === "Top") {
              listElNodesObj[i].classList.add('stackedcards-top', 'stackedcards--animatable', 'stackedcards-origin-top');
              if (this.app.useOverlays) {
                leftObj.classList.add('stackedcards-origin-top');
                rightObj.classList.add('stackedcards-origin-top');
                topObj.classList.add('stackedcards-origin-top');
              }
              elTrans = elTransInc * elTransTop;
              elTransTop--;
            } else if (this.app.stackedOptions === "Bottom") {
              listElNodesObj[i].classList.add('stackedcards-bottom', 'stackedcards--animatable', 'stackedcards-origin-bottom');
              if (this.app.useOverlays) {
                this.app.leftObj.classList.add('stackedcards-origin-bottom');
                this.app.rightObj.classList.add('stackedcards-origin-bottom');
                this.app.topObj.classList.add('stackedcards-origin-bottom');
              }
              elTrans = elTrans + elTransInc;
            } else if (this.app.stackedOptions === "None") {
              listElNodesObj[i].classList.add('stackedcards-none', 'stackedcards--animatable');
              elTrans = elTrans + elTransInc;
            }
            listElNodesObj[i].style.transform = 'scale(' + elScale + ') translateX(0) translateY(' + (elTrans - elTransInc) + 'px) translateZ(0)';
            listElNodesObj[i].style.webkitTransform = 'scale(' + elScale + ') translateX(0) translateY(' + (elTrans - elTransInc) + 'px) translateZ(0)';
            listElNodesObj[i].style.opacity = elOpac;
            listElNodesObj[i].style.zIndex = elZindex;
            elScale = elScale - 0.04;
            elOpac = elOpac - (1 / this.app.items);
            elZindex--;
          }
        }
      });
    },
    // left: function () {
    //   if (!(this.currentPosition >= this.maxElements)) {
    //     if (this.useOverlays) {
    //       this.leftObj.classList.remove('no-transition');
    //       this.topObj.classList.remove('no-transition');
    //       this.leftObj.style.zIndex = '8';
    //       this.transformUi(0, 0, 1, leftObj);
    //     }
    //     this.onSwipeLeft();
    //     this.resetOverlayLeft();
    //   }
    // },
    // right: function () {
    //   if (!(this.currentPosition >= this.maxElements)) {
    //     if (this.useOverlays) {
    //       this.rightObj.classList.remove('no-transition');
    //       this.topObj.classList.remove('no-transition');
    //       this.rightObj.style.zIndex = '8';
    //       this.transformUi(0, 0, 1, rightObj);
    //     }
    //     this.onSwipeRight();
    //     this.resetOverlayRight();
    //   }
    // },
    onSwipeLeft: function () {
      this.removeNoTransition();
      this.transformUi(-1000, 0, 1, this.currentElementObj);
      if (this.useOverlays) {
        this.transformUi(-1000, 0, 0, leftObj); //Move leftOverlay
        this.transformUi(-1000, 0, 0, topObj); //Move topOverlay
        this.resetOverlayLeft();
      }
      this.currentPosition = this.currentPosition + 1;
      this.updateCard();
      this.currentElement();
      this.setActiveHidden();
    },
    onSwipeRight: function () {
      this.removeNoTransition();
      this.transformUi(1000, 0, 0, this.currentElementObj);
      if (this.useOverlays) {
        this.transformUi(1000, 0, 0, rightObj); //Move rightOverlay
        this.transformUi(1000, 0, 0, topObj); //Move topOverlay
        this.resetOverlayRight();
      }
      if (this.currentPosition > 0) {
        this.currentPosition = this.currentPosition - 1;
      }
      this.updateCard();
      this.currentElement();
      this.setActiveHidden();
    },
    onSwipeTop: function () {
      this.removeNoTransition();
      this.transformUi(0, -1000, 1, this.currentElementObj);
      if (this.useOverlays) {
        this.transformUi(0, -1000, 1, leftObj); //Move leftOverlay
        this.transformUi(0, -1000, 1, rightObj); //Move rightOverlay
        this.transformUi(0, -1000, 1, topObj); //Move topOverlay
        this.resetOverlays();
      }
      this.currentPosition = this.currentPosition + 1;
      this.updateCard();
      this.currentElement();
      this.setActiveHidden();
    },
    removeNoTransition: function () {
      if (this.listElNodesObj[this.currentPosition]) {
        if (this.useOverlays) {
          leftObj.classList.remove('no-transition');
          rightObj.classList.remove('no-transition');
          topObj.classList.remove('no-transition');
        }
        this.listElNodesObj[this.currentPosition].classList.remove('no-transition');
        this.listElNodesObj[this.currentPosition].style.zIndex = 6;
      }
    },
    transformUi: function (moveX, moveY, opacity, elementObj) {
      requestAnimationFrame(function () {
        var element = elementObj;

        // Function to generate rotate value
        function RotateRegulator (value) {
          if (value / 10 > 15) {
            return 15;
          }
          else if (value / 10 < -15) {
            return -15;
          }
          return value / 10;
        }

        if (this.rotate) {
          rotateElement = RotateRegulator(moveX);
        } else {
          rotateElement = 0;
        }
        if (this.app.stackedOptions === "Top") {
          elTrans = this.app.elementsMargin * (this.app.items - 1);
          if (element) {
            element.style.webkitTransform = "translateX(" + moveX + "px) translateY(" + (moveY + elTrans) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
            element.style.transform = "translateX(" + moveX + "px) translateY(" + (moveY + elTrans) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
            element.style.opacity = opacity;
          }
        } else if (this.app.stackedOptions === "Bottom" || this.app.stackedOptions === "None") {
          if (element) {
            element.style.webkitTransform = "translateX(" + moveX + "px) translateY(" + (moveY) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
            element.style.transform = "translateX(" + moveX + "px) translateY(" + (moveY) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
            element.style.opacity = opacity;
          }
        }
      });
    },
    currentElement: function () {
      this.currentElementObj = this.listElNodesObj[this.currentPosition];
    },
    setActiveHidden: function () {
      if (!(this.currentPosition >= this.maxElements)) {
        var currentPosition = this.currentPosition;
        if (currentPosition === 0) {
          currentPosition = 1;
        }
        this.listElNodesObj[currentPosition - 1].classList.remove('stackedcards-active');
        this.listElNodesObj[currentPosition - 1].classList.add('stackedcards-hidden');
        this.listElNodesObj[currentPosition].classList.add('stackedcards-active');
      }
    },
    resetOverlayLeft: function () {
      if (!(this.currentPosition >= this.maxElements)) {
        if (this.useOverlays) {
          setTimeout(function () {
            if (this.app.stackedOptions === "Top") {
              elTrans = elementsMargin * (items - 1);
            } else if (this.app.stackedOptions === "Bottom" || this.app.stackedOptions === "None") {
              elTrans = 0;
            }
            if (!this.app.isFirstTime) {
              leftObj.classList.add('no-transition');
              topObj.classList.add('no-transition');
            }
            requestAnimationFrame(function () {
              leftObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              leftObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              topObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              topObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
            });
          }, 300);
          this.isFirstTime = false;
        }
      }
    },
    resetOverlayRight: function () {
      //Move the overlay right to initial position.
      if (!(this.currentPosition >= this.maxElements)) {
        if (this.useOverlays) {
          setTimeout(function () {
            if (this.app.stackedOptions === "Top") {
              elTrans = elementsMargin * (items - 1);
            } else if (this.app.stackedOptions === "Bottom" || this.app.stackedOptions === "None") {
              elTrans = 0;
            }
            if (!isFirstTime) {
              rightObj.classList.add('no-transition');
              topObj.classList.add('no-transition');
            }
            requestAnimationFrame(function () {
              rightObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              rightObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              rightObj.style.opacity = '0';
              topObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              topObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
              topObj.style.opacity = '0';
            });
          }, 300);
          isFirstTime = false;
        }
      }
    },
    iniciarCard: function (objId) {
      Vue.nextTick(function () {
        this.app.body = document.getElementById('body');
        this.obj = document.getElementById(objId);
        this.stackedCardsObj = this.obj.querySelector('.stackedcards-container');
        this.app.listElNodesObj = this.stackedCardsObj.children;
        this.app.topObj = this.obj.querySelector('.stackedcards-overlay.top');
        this.app.rightObj = this.obj.querySelector('.stackedcards-overlay.right');
        this.app.leftObj = this.obj.querySelector('.stackedcards-overlay.left');
        countElements();
        currentElement();
        this.listElNodesWidth = this.stackedCardsObj.offsetWidth;
        this.app.currentElementObj = this.app.listElNodesObj[0];
        this.app.updateCard()
        //Prepare elements on DOM
        this.addMargin = this.app.elementsMargin * (this.app.items - 1) + 'px';
        if (this.app.stackedOptions === "Top") {
          for (i = this.items; i < this.maxElements; i++) {
            this.listElNodesObj[i].classList.add('stackedcards-top', 'stackedcards--animatable', 'stackedcards-origin-top');
          }
          this.elTrans = this.elementsMargin * (this.items - 1);
          this.stackedCardsObj.style.marginBottom = this.addMargin;
        } else if (this.app.stackedOptions === "Bottom") {
          for (var i = this.app.items; i < this.app.maxElements; i++) {
            this.app.listElNodesObj[i].classList.add('stackedcards-bottom', 'stackedcards--animatable', 'stackedcards-origin-bottom');
          }
          this.elTrans = 0;
          this.stackedCardsObj.style.marginBottom = this.addMargin;
        } else if (this.stackedOptions === "None") {
          for (i = this.items; i < this.maxElements; i++) {
            this.listElNodesObj[i].classList.add('stackedcards-none', 'stackedcards--animatable');
          }
          this.elTrans = 0;
        }
        for (i = this.app.items; i < this.app.maxElements; i++) {
          this.app.listElNodesObj[i].style.zIndex = 0;
          this.app.listElNodesObj[i].style.opacity = 0;
          this.app.listElNodesObj[i].style.webkitTransform = 'scale(' + (1 - (this.app.items * 0.04)) + ') translateX(0) translateY(' + elTrans + 'px) translateZ(0)';
          this.app.listElNodesObj[i].style.transform = 'scale(' + (1 - (this.app.items * 0.04)) + ') translateX(0) translateY(' + elTrans + 'px) translateZ(0)';
        }
        if (this.app.listElNodesObj[this.app.currentPosition]) {
          this.app.listElNodesObj[this.app.currentPosition].classList.add('stackedcards-active');
        }
        if (this.app.useOverlays) {
          this.leftObj.style.transform = 'translateX(0px) translateY(' + elTrans + 'px) translateZ(0px) rotate(0deg)';
          this.leftObj.style.webkitTransform = 'translateX(0px) translateY(' + elTrans + 'px) translateZ(0px) rotate(0deg)';
          this.rightObj.style.transform = 'translateX(0px) translateY(' + elTrans + 'px) translateZ(0px) rotate(0deg)';
          this.rightObj.style.webkitTransform = 'translateX(0px) translateY(' + elTrans + 'px) translateZ(0px) rotate(0deg)';
          this.topObj.style.transform = 'translateX(0px) translateY(' + elTrans + 'px) translateZ(0px) rotate(0deg)';
          this.topObj.style.webkitTransform = 'translateX(0px) translateY(' + elTrans + 'px) translateZ(0px) rotate(0deg)';
        } else if (this.app.leftOb) {
          this.app.leftObj.className = '';
          this.app.rightObj.className = '';
          this.app.topObj.className = '';
          this.app.leftObj.classList.add('stackedcards-overlay-hidden');
          this.app.rightObj.classList.add('stackedcards-overlay-hidden');
          this.app.topObj.classList.add('stackedcards-overlay-hidden');
        }
        //Remove class init
        setTimeout(function () {
          this.obj.classList.remove('init');
        }, 150);

        function backToMiddle () {
          removeNoTransition();
          transformUi(0, 0, 1, currentElementObj);
          if (useOverlays) {
            transformUi(0, 0, 0, leftObj);
            transformUi(0, 0, 0, rightObj);
            transformUi(0, 0, 0, topObj);
          }
          setZindex(5);
          if (!(currentPosition >= maxElements)) {
            //roll back the opacity of second element
            if ((currentPosition + 1) < maxElements) {
              listElNodesObj[currentPosition + 1].style.opacity = '.8';
            }
          }
        };

        // Usable functions
        function countElements () {
          this.app.maxElements = this.app.listElNodesObj.length;
          if (this.app.items > this.app.maxElements) {
            this.app.items = this.app.maxElements;
          }
        };

        //Keep the active card.
        function currentElement () {
          this.app.currentElementObj = this.app.listElNodesObj[this.app.currentPosition];
        };

        //Functions to swipe left elements on logic external action.
        function onActionLeft () {
          if (!(currentPosition >= maxElements)) {
            if (useOverlays) {
              leftObj.classList.remove('no-transition');
              topObj.classList.remove('no-transition');
              leftObj.style.zIndex = '8';
              transformUi(0, 0, 1, leftObj);
            }
            setTimeout(function () {
              onSwipeLeft();
              resetOverlayLeft();
            }, 300);
          }
        };
        //Functions to swipe top elements on logic external action.
        //Swipe active card to left.
        function onSwipeLeft () {
          removeNoTransition();
          transformUi(-1000, 0, 0, currentElementObj);
          if (useOverlays) {
            transformUi(-1000, 0, 0, leftObj); //Move leftOverlay
            transformUi(-1000, 0, 0, topObj); //Move topOverlay
            resetOverlayLeft();
          }
          currentPosition = currentPosition + 1;
          updateUi();
          currentElement();
          setActiveHidden();
        };

        //Swipe active card to right.
        function onSwipeRight () {
          removeNoTransition();
          transformUi(1000, 0, 0, currentElementObj);
          if (useOverlays) {
            transformUi(1000, 0, 0, rightObj); //Move rightOverlay
            transformUi(1000, 0, 0, topObj); //Move topOverlay
            resetOverlayRight();
          }
          if (currentPosition > 0) {
            currentPosition = currentPosition - 1;
          }
          updateUi();
          currentElement();
          setActiveHidden();
        };

        //Swipe active card to top.
        function onSwipeTop () {
          removeNoTransition();
          transformUi(0, -1000, 0, currentElementObj);
          if (useOverlays) {
            transformUi(0, -1000, 0, leftObj); //Move leftOverlay
            transformUi(0, -1000, 0, rightObj); //Move rightOverlay
            transformUi(0, -1000, 0, topObj); //Move topOverlay
            resetOverlays();
          }
          currentPosition = currentPosition + 1;
          updateUi();
          currentElement();
          setActiveHidden();
        };

        //Remove transitions from all elements to be moved in each swipe movement to improve perfomance of stacked cards.
        function removeNoTransition () {
          if (listElNodesObj[currentPosition]) {
            if (useOverlays) {
              leftObj.classList.remove('no-transition');
              rightObj.classList.remove('no-transition');
              topObj.classList.remove('no-transition');
            }
            listElNodesObj[currentPosition].classList.remove('no-transition');
            listElNodesObj[currentPosition].style.zIndex = 6;
          }
        };

        //Move the overlay left to initial position.
        function resetOverlayLeft () {
          if (!(currentPosition >= maxElements)) {
            if (useOverlays) {
              setTimeout(function () {
                if (stackedOptions === "Top") {
                  elTrans = elementsMargin * (items - 1);
                } else if (stackedOptions === "Bottom" || stackedOptions === "None") {
                  elTrans = 0;
                }
                if (!isFirstTime) {
                  leftObj.classList.add('no-transition');
                  topObj.classList.add('no-transition');
                }
                requestAnimationFrame(function () {
                  leftObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  leftObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  leftObj.style.opacity = '0';
                  topObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  topObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  topObj.style.opacity = '0';
                });
              }, 300);
              isFirstTime = false;
            }
          }
        };

        //Move the overlay right to initial position.
        function resetOverlayRight () {
          if (!(currentPosition >= maxElements)) {
            if (useOverlays) {
              setTimeout(function () {
                if (stackedOptions === "Top") {
                  +2
                  elTrans = elementsMargin * (items - 1);
                } else if (stackedOptions === "Bottom" || stackedOptions === "None") {
                  elTrans = 0;
                }
                if (!isFirstTime) {
                  rightObj.classList.add('no-transition');
                  topObj.classList.add('no-transition');
                }
                requestAnimationFrame(function () {
                  rightObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  rightObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  rightObj.style.opacity = '0';
                  topObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  topObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  topObj.style.opacity = '0';
                });
              }, 300);
              isFirstTime = false;
            }
          }
        };

        //Move the overlays to initial position.
        function resetOverlays () {
          if (!(currentPosition >= maxElements)) {
            if (useOverlays) {
              setTimeout(function () {
                if (stackedOptions === "Top") {
                  elTrans = elementsMargin * (items - 1);
                } else if (stackedOptions === "Bottom" || stackedOptions === "None") {
                  elTrans = 0;
                }
                if (!isFirstTime) {
                  leftObj.classList.add('no-transition');
                  rightObj.classList.add('no-transition');
                  topObj.classList.add('no-transition');
                }
                requestAnimationFrame(function () {
                  leftObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  leftObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  leftObj.style.opacity = '0';
                  rightObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  rightObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  rightObj.style.opacity = '0';
                  topObj.style.transform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  topObj.style.webkitTransform = "translateX(0) translateY(" + elTrans + "px) translateZ(0)";
                  topObj.style.opacity = '0';
                });
              }, 300);	// wait for animations time
              isFirstTime = false;
            }
          }
        };

        function setActiveHidden () {
          if (!(currentPosition >= maxElements)) {
            listElNodesObj[currentPosition - 1].classList.remove('stackedcards-active');
            listElNodesObj[currentPosition - 1].classList.add('stackedcards-hidden');
            listElNodesObj[currentPosition].classList.add('stackedcards-active');
          }
        };

        //Set the new z-index for specific card.
        function setZindex (zIndex) {
          if (listElNodesObj[currentPosition]) {
            listElNodesObj[currentPosition].style.zIndex = zIndex;
          }
        };
        // Remove element from the DOM after swipe. To use this method you need to call this function in onSwipeLeft, onSwipeRight and onSwipeTop and put the method just above the variable 'currentPosition = currentPosition + 1'.
        //On the actions onSwipeLeft, onSwipeRight and onSwipeTop you need to remove the currentPosition variable (currentPosition = currentPosition + 1) and the function setActiveHidden
        function removeElement () {
          currentElementObj.remove();
          if (!(currentPosition >= maxElements)) {
            listElNodesObj[currentPosition].classList.add('stackedcards-active');
          }
        };

        //Add translate X and Y to active card for each frame.
        function transformUi (moveX, moveY, opacity, elementObj) {
          requestAnimationFrame(function () {
            var element = elementObj;

            // Function to generate rotate value
            function RotateRegulator (value) {
              if (value / 10 > 15) {
                return 15;
              }
              else if (value / 10 < -15) {
                return -15;
              }
              return value / 10;
            }

            if (rotate) {
              rotateElement = RotateRegulator(moveX);
            } else {
              rotateElement = 0;
            }
            if (stackedOptions === "Top") {
              elTrans = elementsMargin * (items - 1);
              if (element) {
                element.style.webkitTransform = "translateX(" + moveX + "px) translateY(" + (moveY + elTrans) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
                element.style.transform = "translateX(" + moveX + "px) translateY(" + (moveY + elTrans) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
                element.style.opacity = opacity;
              }
            } else if (stackedOptions === "Bottom" || stackedOptions === "None") {
              if (element) {
                element.style.webkitTransform = "translateX(" + moveX + "px) translateY(" + (moveY) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
                element.style.transform = "translateX(" + moveX + "px) translateY(" + (moveY) + "px) translateZ(0) rotate(" + rotateElement + "deg)";
                element.style.opacity = opacity;
              }
            }
          });
        };
        //Action to update all elements on the DOM for each stacked card.
        //Touch events block
        var element = this.obj;
        var startTime;
        var startX;
        var startY;
        var translateX;
        var translateY;
        var currentX;
        var currentY;
        var touchingElement = false;
        var timeTaken;
        var topOpacity;
        var rightOpacity;
        var leftOpacity;

        function setOverlayOpacity () {
          topOpacity = (((translateY + (elementHeight) / 2) / 100) * -1);
          rightOpacity = translateX / 100;
          leftOpacity = ((translateX / 100) * -1);
          if (topOpacity > 1) {
            topOpacity = 1;
          }
          if (rightOpacity > 1) {
            rightOpacity = 1;
          }
          if (leftOpacity > 1) {
            leftOpacity = 1;
          }
        }

        function gestureStart (evt) {
          startTime = new Date().getTime();
          startX = evt.changedTouches[0].clientX;
          startY = evt.changedTouches[0].clientY;
          currentX = startX;
          currentY = startY;
          setOverlayOpacity();
          touchingElement = true;
          if (!(currentPosition >= maxElements)) {
            if (listElNodesObj[currentPosition]) {
              listElNodesObj[currentPosition].classList.add('no-transition');
              setZindex(6);
              if (useOverlays) {
                leftObj.classList.add('no-transition');
                rightObj.classList.add('no-transition');
                topObj.classList.add('no-transition');
              }
              if ((currentPosition + 1) < maxElements) {
                listElNodesObj[currentPosition + 1].style.opacity = '1';
              }
              elementHeight = listElNodesObj[currentPosition].offsetHeight / 3;
            }
          }
        };

        function gestureMove (evt) {
          currentX = evt.changedTouches[0].pageX;
          currentY = evt.changedTouches[0].pageY;
          // console.log(currentX + '-' + currentY)
          translateX = currentX - startX;
          translateY = currentY - startY;
          // setOverlayOpacity();
          // if (!(currentPosition >= maxElements)) {
          //   evt.preventDefault();
          //   transformUi(translateX, translateY, 1, currentElementObj);
          //   if (useOverlays) {
          //     transformUi(translateX, translateY, topOpacity, topObj);
          //     if (translateX < 0) {
          //       transformUi(translateX, translateY, leftOpacity, leftObj);
          //       transformUi(0, 0, 0, rightObj);
          //     } else if (translateX > 0) {
          //       transformUi(translateX, translateY, rightOpacity, rightObj);
          //       transformUi(0, 0, 0, leftObj);
          //     }
          //     if (useOverlays) {
          //       leftObj.style.zIndex = 8;
          //       rightObj.style.zIndex = 8;
          //       topObj.style.zIndex = 7;
          //     }
          //   }
          // }
        };

        function gestureEnd (evt) {
          if (!touchingElement) {
            return;
          }
          translateX = currentX - startX;
          translateY = currentY - startY;
          timeTaken = new Date().getTime() - startTime;
          touchingElement = false;
          if (!(currentPosition >= maxElements)) {
            if (translateY < (elementHeight * -1) && translateX > ((listElNodesWidth / 2) * -1) && translateX < (listElNodesWidth / 2)) {  //is Top?
              if (translateY < (elementHeight * -1) || (Math.abs(translateY) / timeTaken > velocity)) { // Did It Move To Top?
                onSwipeTop();
              } else {
                backToMiddle();
              }
            } else {
              if (translateX < 0) {
                if (translateX < ((listElNodesWidth / 2) * -1) || (Math.abs(translateX) / timeTaken > velocity)) { // Did It Move To Left?
                  onSwipeLeft();
                } else {
                  backToMiddle();
                }
              } else if (translateX > 0) {
                if (translateX > (listElNodesWidth / 2) && (Math.abs(translateX) / timeTaken > velocity)) { // Did It Move To Right?
                  onSwipeRight();
                } else {
                  backToMiddle();
                }
              }
            }
          }
        };
      })
    }
  }
}
